# $Id: smeserver-trac.spec,v 1.28 2008/12/29 15:40:22 marcohess Exp $
# Authority: marcohess
# Name: Marco Hess

%define name smeserver-trac
%define version 0.4
%define release 56

Name: %{name}
Summary: Trac for SME Server
Version: %{version}
Release: %{release}%{?dist}
License: GPL
Group: Applications/Internet
Source: %{name}-%{version}.tgz
Patch1: smeserver-trac-0.4-lexicon-spelling-update.patch
Patch2: smeserver-trac-0.4-locale-2008-04-01.patch
Patch3: smeserver-trac-0.4-locale-2008-04-22.patch
Patch4: smeserver-trac-0.4-locale-2008-04-23.patch
Patch5: smeserver-trac-0.4-newlines.patch
Patch6: smeserver-trac-0.4-add2general.patch
Patch7: smeserver-trac-0.4-locale-2008-05-05.patch
Patch8: smeserver-trac-0.4-locale-2008-05-07.patch
Patch9: smeserver-trac-0.4-locale-2008-05-21.patch
Patch10: smeserver-trac-0.4-locale-2008-06-27.patch
Patch11: smeserver-trac-0.4-locale-2008-07-01.patch
Patch12: smeserver-trac-0.4-comment.patch
Patch13: smeserver-trac-0.4-locale-2008-09-23.patch
Patch14: smeserver-trac-0.4-locale-2008-10-14.patch
Patch15: smeserver-trac-0.4-locale-2008-11-05.patch
Patch16: smeserver-trac-0.4-locale-2008-11-30.patch
Patch17: smeserver-trac-0.4-lexicon-extra-entry-tag-fix.patch
Patch18: smeserver-trac-0.4-trac-ini-ownership.patch  
Patch19: smeserver-trac-0.4-locale-2009-01-01.patch
BuildArch: noarch
BuildRequires: e-smith-devtools
BuildRoot: /var/tmp/%{name}-%{version}-%{release}-buildroot
Requires: trac >= 0.10.3
Requires: smeserver-mod_python 
Requires: perl-Config-IniFiles 
Requires: python-docutils >= 0.4
Requires: python-silvercity >= 0.9.5
Requires: python-setuptools >= 0.6
Requires: smeserver-subversion >= 1.2
Requires: subversion-python 
Requires: smeserver-release >= 7
Requires: httpd >= 2
Requires: e-smith-formmagick >= 1.4.0-12


%description
Trac project environments integration for SME Server 7

%changelog
* Thu Jan  1 2009 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-56
- Apply  1 Jan 2009 locale patch [SME: 4900]

* Tue Dec 30 2008 Marco Hess <marco.hess@through-ip.com> 0.4-55
- Updated bug references in spec file.

* Tue Dec 30 2008 Marco Hess <marco.hess@through-ip.com> 0.4-54
- Fixed trac.ini file ownership problem after trac-project-modify for [SME: 4428]

* Tue Dec 30 2008 Marco Hess <marco.hess@through-ip.com> 0.4-53
- Fixed error in lexicon file wich had an extra <entry> tag for [SME: 4902]

* Sun Nov 30 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-52
- Apply 30 Nov 2008 locale patch

* Wed Nov  5 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-51
- Apply  5 Nov 2008 locale patch

* Tue Oct 14 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-50
- Apply 14 Oct 2008 locale patch

* Tue Sep 23 2008 Stephen Noble <support@dungog.net> 0.4-49
- Apply 23 Sep 2008 locale patch

* Tue Jul 1 2008 Shad L. Lords <slords@mail.com> 0.4-48
- Remove comment header from locale file

* Tue Jul 1 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-47
- Apply 1 July 2008 locale patch

* Fri Jun 27 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-46
- Apply 27 Jun 2008 locale patch

* Thu May 21 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-45
- Apply 21 May 2008 locale patch

* Wed May 7 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-44
- Apply 7 May 2008 locale patch

* Mon May 5 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-43
- Apply 5 May 2008 locale patch

* Sat Apr 26 2008 Shad L. Lords <slords@mail.com> 0.4-42
- Fix patch to not include locales
- Add patch to fix newlines

* Sat Apr 26 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-41
- Add common <base> tags to e-smith-formmagick's general

* Wed Apr 23 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-40
- Apply 23 April 2008 locale patch

* Tue Apr 22 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-39
- Fix commit date in changelog entry

* Tue Apr 22 2008 Jonathan Martens <smeserver-contribs@snetram.nl> 0.4-38
- Apply 22 April 2008 locale patch

* Tue Apr 1 2008 Shad L. Lords <slords@mail.com> 0.4-37
- Update to UTF-8 translations

* Wed Mar 12 2008 Marco Hess <marco.hess@through-ip.com>
- 0.4-36
  Update the trac lexicon file for some minor spelling errors and
  a minor updates for consistency.

* Wed Dec 5 2007 Marco Hess <marco.hess@through-ip.com>
- 0.4-35
  Removed patch again, as using sighup seems to be creating more
  problems than it solved.

* Wed Dec 5 2007 Marco Hess <marco.hess@through-ip.com>
- 0.4-34
  Added dependency so that subversion-python bindings package is 
  installed. Changed the create links script so that the trac updates
  use sighup to restart httpd services instead of sigusr1

* Tue Aug 14 2007 Marco Hess <marco.hess@through-ip.com>
- 0.4-33
  Updated spec file with new release tag. 
  Made further changes to spec file as per smeserver-mod_python
  spec file.

* Mon Aug 13 2007 Marco Hess <marco.hess@through-ip.com>
- 0.4-32
  Updated the Wiki default start page to no longer
  mention the Trac version number in preparation for use
  with trac 0.10.4

* Sat Jul 13 2007 Marco Hess <marco.hess@through-ip.com>
- 0.4-31
  Fixed bugzilla bug 3129 as per indicated patch 
  (Corrected 'neq' to 'ne' in trac-project-repository-modify)

* Sat Apr 7 2007 Marco Hess <marco.hess@through-ip.com>
- 0.4-1
  Implemented a mechanism whereby when there are more than
  one domain configured on the server, it is possible to
  select in which domains the Trac environment will be 
  visible.

* Sat Apr 7 2007 Marco Hess <marco.hess@through-ip.com>
- 0.3-2
  Removed the hack for the perl Config IniFiles and replaced
  with proper rpm perl-Config-IniFiles

* Mon Apr 2 2007 Marco Hess <marco.hess@through-ip.com>
- 0.3-1
  Added python-docutils as a required package to support
  ReStructuredText formatting in the Trac Wiki.

* Mon Apr 2 2007 Marco Hess <marco.hess@through-ip.com>
- 0.3-0
  Readied package for import in smeserver-contribs CVS space.
  and removed the hack for the true http basic authentication
  logout (Trac Ticket 3577) as this patch is now applied
  in the trac rpm.

* Wed Mar 28 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-10
  Included an option in the httpd template to include a
  PythonOption TracLocale. The language is pulled from the
  configuration database sysconfig->Language entry so it
  reflects the installed system locale.

* Tue Mar 27 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-9
  Bumped the number to test upgrades not deleting the
  existing trac project environments.

* Tue Mar 27 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-8
  Still a small error :-) in the uninstall that still
  removed existing trac project environments.

* Tue Mar 27 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-7
  Bumped the number to test upgrades not deleting the
  existing trac project environments.

* Tue Mar 27 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-6
  Fixed the spec file so that on upgrades of the 
  smeserver-trac package we don't throw away the 
  existing Trac project environments :-( 
  Also added missing account name error message to 
  en-us locale.

* Tue Mar 27 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-5
  Added a View action to the Trac projects table in the
  server-manager panel so the admin can quickly view the
  Trac project page from there.

* Tue Mar 27 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-4
  Added requirement for python-silvercity so more syntax
  highlighting comes pre-installed with Trac on SME :-)

* Mon Mar 26 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-3
  Fixed error in setting up syslog logging in trac.ini

* Mon Mar 26 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-2
  Added requirement for python-setuptools as this is 
  needed to get the WebAdmin plugin to work.

* Mon Mar 26 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-1
  Removed the creation of a link to the Trac project site as this
  caused problems with the Modify and Remove links in the 
  server-manager panel.

* Mon Mar 26 2007 Marco Hess <marco.hess@through-ip.com>
- 0.2-0
  Converted for Mezzanine build and extracted the mod_python
  requirements into smeserver-mod_python.

* Wed Mar 21 2007 Marco Hess <marco.hess@through-ip.com>
- 0.1
  Initial package

%prep

%setup
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1

%build
perl createlinks

DEFAULTS=root/etc/e-smith/db/configuration/defaults/maxTracNameLength
mkdir -p $DEFAULTS
echo "31"  > $DEFAULTS/type

%install
rm -rf $RPM_BUILD_ROOT
(cd root ; find . -depth -print | cpio -dump $RPM_BUILD_ROOT)
rm -f %{name}-%{version}-filelist
/sbin/e-smith/genfilelist $RPM_BUILD_ROOT > %{name}-%{version}-filelist

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = "1" ] ; then  # first install

echo "Creating trac projects parent directory ..."
mkdir -p /home/e-smith/files/trac

echo "Inserting SME Powered logo in Trac Footer ..."
cp /usr/share/trac/templates/footer.cs.sme-patched /usr/share/trac/templates/footer.cs
chown www:www /usr/share/trac/templates/footer.cs

echo "Creating custom SME WikeStart page ..."
mv   /usr/share/trac/wiki-default/WikiStart.sme-patched /usr/share/trac/wiki-default/WikiStart

echo "Enabling mod_python for webserver ..."
/sbin/e-smith/db configuration set modPython service status enabled

echo "Setting maximum trac projects name length to 31 ..."
/sbin/e-smith/db configuration set maxTracNameLength 31

echo "You need to create an pseudonym or a group called 'trac'"
echo "   to support the reply-to address in the trac email notifications ..."

echo "Expanding templates ..."
/sbin/e-smith/signal-event trac-modify

echo "Rebuilding server-manager (this can take a while) ..."

/etc/e-smith/events/actions/initialize-default-databases
/etc/e-smith/events/actions/navigation-conf
/sbin/e-smith/expand-template /etc/httpd/conf/httpd.conf
/etc/rc7.d/S86httpd-e-smith sighup
fi
true

%preun
if [ "$1" = "0" ] ; then  # last uninstall
/sbin/e-smith/signal-event trac-delete
/sbin/e-smith/signal-event trac-modify
fi
true

%postun
if [ "$1" = "0" ] ; then  # last uninstall
# Remove the parent directory
echo "Removing trac projects parent directory ..."
/bin/rmdir /home/e-smith/files/trac
fi
true

# Expand the server-manager templates to update/remove
# references to the smeserver-trac panel
echo "Rebuilding server-manager (this can take a while) ..."
/sbin/e-smith/expand-template /etc/httpd/conf/httpd.conf
/etc/e-smith/events/actions/navigation-conf
/etc/rc7.d/S86httpd-e-smith sighup

%files -f %{name}-%{version}-filelist
%defattr(-,root,root)
